const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const box_items = sequelize.define(
    'box_items',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

item_kind: {
        type: DataTypes.ENUM,
      
      

        values: [

"avatar",


"cosmetic"

        ],

      },

rarity: {
        type: DataTypes.ENUM,
      
      

        values: [

"common",


"uncommon",


"rare",


"epic",


"legendary",


"mythic"

        ],

      },

drop_rate_percent: {
        type: DataTypes.DECIMAL,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  box_items.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity





































//end loop



    db.box_items.belongsTo(db.boxes, {
      as: 'box',
      foreignKey: {
        name: 'boxId',
      },
      constraints: false,
    });

    db.box_items.belongsTo(db.avatars, {
      as: 'avatar',
      foreignKey: {
        name: 'avatarId',
      },
      constraints: false,
    });

    db.box_items.belongsTo(db.cosmetics, {
      as: 'cosmetic',
      foreignKey: {
        name: 'cosmeticId',
      },
      constraints: false,
    });




    db.box_items.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.box_items.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return box_items;
};


